/*
 * Copyright 2023 Li.Xionghui Inc.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include <stdio.h>
#include <stdint.h>
#include <assert.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

#define el_uint32_t                 uint32_t
enum elang_ext_data_type{
    ELANG_EXT_DATA_STR = 0,
    ELANG_EXT_DATA_NIL,
    ELANG_EXT_DATA_FLOAT,
    ELANG_EXT_DATA_LIST,
};
typedef enum elang_ext_data_type elang_ext_data_type_t;

int elang_ext_boot_hook(void** vm);
int elang_ext_exit_hook(void** vm);
int elang_ext_new_state(void** vm);
int elang_ext_register_func(void** vm,char* func_name,int (*cb)(void* vm));
int elang_ext_pop_arg(void** vm,elang_ext_data_type_t *type,unsigned char** data,float* fnum,el_uint32_t* len);
int elang_ext_set_return_var(void** vm,el_uint32_t index);
el_uint32_t elang_ext_new_str_var(void** vm,unsigned char* data,el_uint32_t len);
el_uint32_t elang_ext_new_nil_var(void** vm);
el_uint32_t elang_ext_new_float_var(void** vm,float* value);

int elang_ext_set_code(void** vm,const char* code);
int elang_ext_run(void** vm);
int elang_ext_get_mem_used(void** vm,el_uint32_t* item,el_uint32_t* size);
int elang_ext_add_code(void** vm,const char* code);
int elang_ext_run_auto(void** vm);
el_uint32_t elang_ext_get_instr_count(void** vm,float* value);
